"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateGif = void 0;
const fluent_ffmpeg_1 = __importDefault(require("fluent-ffmpeg"));
const geturl_1 = require("./lib/geturl");
const DEFAULT_FPS = 18;
const DEFAULT_DURATION = 3;
const DEFAULT_WIDTH = 320;
const DEFAULT_START = 0; // Default start of GIF to beginning of video
const generateGif = (url, outputFile, options) => __awaiter(void 0, void 0, void 0, function* () {
    const videoUrl = yield geturl_1.getUrl(url);
    return new Promise((resolve, reject) => __awaiter(void 0, void 0, void 0, function* () {
        return fluent_ffmpeg_1.default()
            .input(videoUrl)
            .inputOptions([`-ss ${(options === null || options === void 0 ? void 0 : options.startInSeconds) || DEFAULT_START}`])
            .outputOptions([
            `-t ${(options === null || options === void 0 ? void 0 : options.duration) || DEFAULT_DURATION}`,
            `-vf fps=${(options === null || options === void 0 ? void 0 : options.fps) || DEFAULT_FPS},scale=${(options === null || options === void 0 ? void 0 : options.width) || DEFAULT_WIDTH}:-1:flags=lanczos`,
        ])
            .noAudio()
            .output(outputFile)
            .on("end", () => {
            resolve(outputFile);
        })
            .on("error", reject)
            .run();
    }));
});
exports.generateGif = generateGif;
exports.default = exports.generateGif;
//# sourceMappingURL=main.js.map