import ytdl, { videoFormat } from "ytdl-core";

export const getUrl = async (url: string): Promise<string> => {
  const res = await ytdl.getInfo(url);
  const { formats } = res;
  const videoFormats = formats.filter((e) => !!e.width);
  const mediumQualityVideo: videoFormat | null = videoFormats.find(
    (e) => e.quality === "medium"
  );
  let video: videoFormat = mediumQualityVideo;
  if (!mediumQualityVideo) {
    video = videoFormats[videoFormats.length - 1];
  }

  return video.url;
};
